package com.zsc.edu.gateway.modules.operationLog.entity;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.zsc.edu.gateway.common.enums.IState;
import lombok.*;

import java.time.LocalDateTime;

/**
 * @author zhuang
 */
@Setter
@Getter
@NoArgsConstructor
@AllArgsConstructor
@TableName("operation_log")
public class OperationLog {
    /**
     * 主键
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 模块类型
     */
    private ModelType modelType;

    /**
     * 操作类型
     */
    private OperationType operationType;

    /**
     * 操作内容
     */
    private String content;

    /**
     * 操作时间
     */
    private LocalDateTime makeTime;

    public enum ModelType implements IEnum<Integer>, IState<ModelType> {
        ATTACHMENT(1, "附件模块"),
        IOT(2, "物模型模块"),
        MESSAGE(3, "公告消息模块"),
        SYSTEM(4, "系统模块");

        private final Integer value;
        private final String name;

        ModelType(int value, String name) {
            this.value = value;
            this.name = name;
        }

        @Override
        public Integer getValue() {
            return this.value;
        }

        @Override
        public String toString() {
            return this.name;
        }
    }

    public enum OperationType implements IEnum<Integer>, IState<OperationType> {
        CREATE(1, "添加"),
        UPDATE(2, "更新"),
        DELETE(3, "删除");

        private final Integer value;
        private final String name;

        OperationType(int value, String name) {
            this.value = value;
            this.name = name;
        }

        @Override
        public Integer getValue() {
            return this.value;
        }

        @Override
        public String toString() {
            return this.name;
        }
    }
}
